<?php
/**
 * Déclaration de la classe CommandLine\Argument\ParseResult.
 */
namespace CommandLine\Argument;

use Fidit\v3\AutoProperty;

/**
 * Résultat du parsage d'un argument
 *
 * @property int   $consume {@see $_consume $_consume}
 * @property mixed $value   {@see $_value   $_value  }
 *
 * @package CommandLine\Argument
 */
class ParseResult extends AutoProperty {
    /**
     * @var int Le nombre d'argument consumé.
     */
    protected $_consume;
    /**
     * @var mixed La valeur.
     */
    protected $_value;

    /**
     * ArgumentParseResult constructor.
     *
     * @param mixed $value   La valeur.
     * @param int   $consume Le nombre d'argument consumé.
     */
    public function __construct ($value, $consume = 1) {
        $this->setValue($value);
        $this->setConsume($consume);
    }

    /**
     * Le nombre d'argument consumé.
     *
     * @return int Le nombre d'argument consumé.
     *
     * @see $_consume
     */
    public function getConsume() {
        return $this->_consume;
    }
    /**
     * Définit le nombre d'argument consumé.
     *
     * @param $consume int Le nombre d'argument consumé.
     *
     * @return $this
     *
     * @see $_consume
     */
    public function  setConsume($consume) {
        $this->_consume = $consume;
        return $this;
    }

    /**
     * La valeur.
     *
     * @return mixed La valeur.
     *
     * @see $_value
     */
    public function getValue() {
        return $this->_value;
    }
    /**
     * Définit les valeurs définies.
     *
     * @param mixed $value La valeur.
     *
     * @return $this
     *
     * @see $_value
     */
    public function  setValue($value) {
        $this->_value = $value;
        return $this;
    }
}