<?php
/**
 * Déclaration de la classe CommandLine\Argument\Parser\BooleanParser
 */
namespace CommandLine\Argument\Parser;

use Fidit\v3\Exception\InvalidArgument;

/**
 * Parseur vers un booléen
 *
 * Les valeurs suivantes sont acceptées :
 * - true , 1, oui, vrai
 * - false, 0, non, faux
 *
 * @package CommandLine\Argument\Parser
 */
class BooleanParser implements IValueParser {
    public function parseValue ($arg) {
        if(!in_array($arg, array(
            'true' , '1', 'oui', 'vrai',
            'false', '0', 'non', 'faux',
        )))
            throw new InvalidArgument($arg, 'La valeur n\'est pas un booléen valide');

        return in_array($arg, array('true' , '1', 'oui', 'vrai'));
    }

    public function getValueDescription () {
        return 'boolean';
    }
}